/*
 *	DrawRGBCube()	-	Draws the RGB Cube
 *
 *	RCS:
 *		$Revision$
 *		$Date$
 *
 *	Security:
 *		Unclassified
 *
 *	Description:
 *		macro is from xcol
 *
 *	Input Parameters:
 *		type	identifier	description
 *
 *		text
 *
 *	Output Parameters:
 *		type	identifier	description
 *
 *		text
 *
 *	Return Values:
 *		value	description
 *
 *	Side Effects:
 *		text
 *
 *	Limitations and Comments:
 *		text
 *
 *	Development History:
 *		when	who		why
 *	6/5/94		mm		first cut
 */

#include <xhead.h>
#include "mxcmap.h"

int	
	dx= 400,
	dy= 400;

int
	BO=20;
int
	reverse=0;

int
	ex[8], ey[8];
extern Pixmap
	backpix;

void
DrawRGBCube()
{
#define XPos(r, g, b)   ( (BO>>1)+40+                    \
              ( (reverse)   ? (127+(255-r)-((255-b)>>1))    \
                    : (127+r-((b)>>1))      \
              ) * (dx-BO-4)/384             \
            )
#define YPos(r, g, b)   ( (BO>>1)+30+                    \
              ( (reverse)   ? (g+((255-b)>>1))      \
                    : ((255-g)+(b>>1))      \
              ) * (dy-BO-4)/384             \
            )

	
	XColor
		*colors;
	
	XGCValues
		gc_values;

	GC
		tmpgc;

	register int
		i, j, op;

	unsigned int
		blue;
	
	Window
		window;

	int
		xpos, ypos;
	
	int
		rp,gp,bp;

    int
        cells;
	gc_values.foreground=WhitePixel(display_h,screen_h);


BO=dx/50;
if ((dy/50)>50) BO=(dy/50);

	blue = AllocateColor (display_h, colormap_h,
		0,0,0);

	XSetForeground (display_h, gc_h, blue);

	window = XtWindow(GdrawingaW);

	XClearWindow (display_h, window);
	tmpgc=XCreateGC (display_h, window,
		GCForeground,
		&gc_values);
	XFillRectangle (display_h, backpix,
		tmpgc,
		0,0,512,512);
	XFreeGC (display_h, tmpgc);

	for (i=0; i<8; i++)
	{
		ex[i] = XPos( ((i&1)?255:0), ((i&2)?255:0), ((i&4)?255:0) );
		ey[i] = YPos( ((i&1)?255:0), ((i&2)?255:0), ((i&4)?255:0) );
	}

	for (i=0; i<8; i++)
	{
		for (j=0; j<3; j++)
		{
			op = i^(1<<j);
			if (op <i)
			{
				XDrawLine(display_h, window,
					gc_h,
					ex[i], ey[i], ex[op], ey[op]);
				XDrawLine(display_h, backpix,
					gc_h,
					ex[i], ey[i], ex[op], ey[op]);
			}
		}
	}

    cells = XDisplayCells (display_h, XDefaultScreen(display_h));
	colors = (XColor *) malloc(cells*sizeof(XColor));

	for (i=0; i<cells; i++)
	{
		colors[i].pixel = (unsigned long) i;
	}
	XQueryColors (display_h, colormap_h, colors, cells);
        
	

	for (i=0; i <cells; i++)
	{
		rp=colors[i].red >> 8;
		gp=colors[i].green >>8;
		bp=colors[i].blue >> 8;

		xpos = XPos(rp,gp,bp);
		ypos = YPos (rp,gp,bp);

		XSetForeground (display_h, gc_h, i);
		XFillRectangle (display_h, window, gc_h,
			xpos-(BO>>1), ypos-(BO>>1),BO,BO);
		XFillRectangle (display_h, backpix, gc_h,
			xpos-(BO>>1), ypos-(BO>>1),BO,BO);

	}
	
	if (colors != (XColor *) NULL)
		(void) free ((char *) colors);

	XtAddCallback (GdrawingaW,
		XmNexposeCallback, (XtCallbackProc) Redisplay, NULL);
	XtAddEventHandler (GdrawingaW,
		ButtonPressMask,
		False,
		(XtEventHandler) my_event_handler, NULL);


}

void
Redisplay(w,client_data, call_data)
Widget
	w;
XtPointer client_data;
XmDrawingAreaCallbackStruct *call_data;
{
	XEvent
		*event = call_data->event;

	if (event->xexpose.count == 0)
	{
		refresh_from_backpix(XtWindow(GdrawingaW),
			512,512,
			0,0);
	}
}
