/*
 *	Get_Color()	-	gets the pixel index from the colormap
 *
 *	RCS:
 *		$Revision$
 *		$Date$
 *
 *	Security:
 *		Unclassified
 *
 *	Description:
 *		text
 *
 *	Input Parameters:
 *		type	identifier	description
 *
 *		text
 *
 *	Output Parameters:
 *		type	identifier	description
 *
 *		text
 *
 *	Return Values:
 *		value	description
 *
 *	Side Effects:
 *		text
 *
 *	Limitations and Comments:
 *		text
 *
 *	Development History:
 *		when	who		why
 *	9/23/93, mm, first cut
 */

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <stdio.h>

#define SUCCESS 0
#define ERROR_PARSE 51
#define ERROR_ALLOC 52

unsigned long Get_Color (disp, colmap, name)
Display *disp;
Colormap colmap;

char *name;

{
	XColor def;

	if (XParseColor (disp, colmap, name, &def ))
	{
		if (XAllocColor (disp, colmap, &def))
		{
			return def.pixel;
		}
		else
		{
			fprintf (stderr, "Could not Allocate color: %s\n", name);
			return(ERROR_ALLOC);
		}
	}
	else
	{
		fprintf (stderr, "Could not parse color: %s\n",name);
		return(ERROR_PARSE);
	}
}
