/*
 *	GetTopShell()	- get top level shell
 *
 *	RCS:
 *		$Revision$
 *		$Date$
 *
 *	Security:
 *		Unclassified
 *
 *	Description:
 *		GetTopShell() gets the top level shell of the application.  This
 *		is neccesary when creating a new shell, you must attach it to
 *		the top level shell of the application.
 *
 *	Input Parameters:
 *		type	identifier	description
 *		Widget	w			a widget
 *
 *	Output Parameters:
 *		type	identifier	description
 *		None
 *
 *	Return Values:
 *		value	description
 *		w		widget pointing to top level shell
 *
 *	Side Effects:
 *		None
 *
 *	Limitations and Comments:
 *		None
 *
 *	Development History:
 *		when		who		why
 *		07-Apr-1992	um	function creation
 */
#include "xhead.h"
#include "mxcmap.h"

Widget GetTopShell(w)
Widget
    w;
{

	while (w && !XtIsWMShell(w))
		w = XtParent(w);

	return w;

} /* end GetTopShell */
